#ifndef INCLUDED_PLED_H
#define INCLUDED_PLED_H
 
//GLOBAL
wxBitmap  *bitmap = (wxBitmap *) NULL;
char *orbpath;
wxString orbiter_path;
int def2,def31,def32,def4;


class pled : public wxApp	//clasa principala derivata din WxApp
{
public:
        virtual bool OnInit();	//Scrie peste metoda OnInit() din WxApp cred
};
DECLARE_APP(pled)


//class Canvas;	//declarata aici ca so pot utiliza in Frame
/*BEGIN CANVAS*/

class Canvas: public wxScrolledWindow
{
  public:
    Canvas(wxWindow *parent,wxWindowID id, const wxPoint& pos, const wxSize& size);
   ~Canvas(void){};
    void OnPaint(wxPaintEvent& event);



DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(Canvas, wxScrolledWindow)
    EVT_PAINT(Canvas::OnPaint)
END_EVENT_TABLE()

/*END CANVAS*/


/*BEGIN FRAME*/
class Frame: public wxFrame		//aialalta principala, container pt totu
{
public:
Canvas		*canvas;
//constructoru
Frame(const wxString& title, const wxPoint& pos, const wxSize& size,long style);	
//virtual ~Frame();		//destructoru

wxPanel		*panel;			//panou principal -- parintele la butoane, bitmapuri etc.
wxButton	*button1;

//DE AICI INCEP BUTOANE, LISTE & TRAPE SECRETE

//prima categorie - ...
wxButton	*generate;
wxButton	*randomize;
wxCheckBox  *ii_random;
wxTextCtrl  *seed;


//a 2-a categorie - parametri al modulului generator
wxTextCtrl *frequency;
wxTextCtrl *lacunarity;
wxTextCtrl *octave;
wxTextCtrl *persistence;
wxTextCtrl *stretch;
wxComboBox *rezolutie;


//a 3-a categorie - SA FIE LUMINA
wxTextCtrl *brightness;
wxTextCtrl *colorR;
wxTextCtrl *colorG;
wxTextCtrl *colorB;
wxTextCtrl *contrast;
wxTextCtrl *intensity;

wxSlider   *azimuth;
wxSlider   *elevation;

wxCheckBox  *ni_light;

//a 4-a categorie - gradientii de culoare, lumini si umbre
wxColourDialog *picker;
wxColourData   *date_culoare;
wxColour	   *culoare;
wxString	   *str;

wxButton	*add;
wxButton	*del;
wxTextCtrl  *val;
wxListBox	*box;

int nr_gradienti;




//din meniu
	//din file
	void OnSaveBmp(wxCommandEvent& event);
	void OnSaveTex(wxCommandEvent& event);
	void OnQuit(wxCommandEvent& event);		// fct ce-i de facut in 
	//din options
	void OnDefault(wxCommandEvent& event);
	//din help
	void OnReadme(wxCommandEvent& event);
	void OnAbout (wxCommandEvent& event);

//din program
void OnClik(wxCommandEvent& event);
void OnRand(wxCommandEvent& event);
void OnAdd(wxCommandEvent& event);
void OnDel(wxCommandEvent& event);


private:
wxImage image1;
DECLARE_EVENT_TABLE()
};





enum			//fiecare widget sa aiba un id ( vezi mai jos de ce )
{
ID_Quit		=wxID_HIGHEST + 1,
IDSaveBmp	,
IDSaveTex	,
IDDefault	,
IDReadme	,
IDAbout		,
IDgenerate  ,
IDrand		,
IDadd		,
IDdel		,
};

BEGIN_EVENT_TABLE(Frame, wxFrame)

//meniu
	//file
	EVT_MENU	(IDSaveBmp		, Frame::OnSaveBmp)
	EVT_MENU	(IDSaveTex		, Frame::OnSaveTex)
	EVT_MENU	(ID_Quit		, Frame::OnQuit)
	//options
	EVT_MENU	(IDDefault		, Frame::OnDefault)
	//about
	EVT_MENU	(IDReadme		, Frame::OnReadme)
	EVT_MENU	(IDAbout		, Frame::OnAbout)



//1
EVT_BUTTON	(IDgenerate	, Frame::OnClik )
EVT_BUTTON	(IDrand  	, Frame::OnRand )

//4
EVT_BUTTON	(IDadd	, Frame::OnAdd  )
EVT_BUTTON	(IDdel	, Frame::OnDel  )

END_EVENT_TABLE()
/*END FRAME*/






#endif