//todo: dalea default
#include <stdlib.h>
#include <process.h>
#include <string.h>


//todo: dale libnoise-ului
#include "noise/noise.h"
#include "noiseutils.h"
using namespace noise;

// dale wx-ului
#include "wx/wxprec.h"
#ifndef WX_PRECOMP
       #include "wx/wx.h"
#endif
#include "wx/image.h"
#include "wx/colordlg.h"
#include "wx/process.h"

// dale mele
#include "pled.h"


//wxFrame *frame;

IMPLEMENT_APP(pled)

// <=> cu main() in programe normale
bool pled::OnInit()
{

//fereastra principala. Poate avea status bar,toolbar & alte abureli.

wxFrame *frame = new Frame( "Planet Editor", wxPoint(0,0), wxSize(1024,768),
wxDEFAULT_FRAME_STYLE & ~ (wxMAXIMIZE_BOX)// |( wxRESIZE_BORDER )
						  );
frame->Show(TRUE);
SetTopWindow(frame);


return true;

}

//constructoru la clasa frame
Frame::Frame(const wxString& title, const wxPoint& pos, const wxSize& size,long style)
: wxFrame((wxFrame *)NULL, -1, title, pos, size,style)
{


FILE *f;
f=fopen("config.txt","r");

if (f != NULL)
{
	//fscanf(f,"%s\n",&orbpath);
	//if (orbpath != NULL) orbiter_path.Printf("%s",orbpath);
	fscanf(f,"%d\n",&def2);
	fscanf(f,"%d\n",&def31);
	fscanf(f,"%d\n",&def32);
	fscanf(f,"%d\n",&def4);
}

fclose(f);



wxMenu *file = new wxMenu;				//meniu efectiv ( in cazu asta e File )
file->Append( IDSaveBmp, "Save as .bmp" );
file->Append( IDSaveTex, "Save as .tex" );
file->Append( ID_Quit,   "Exit" );			//exit

wxMenu *options = new wxMenu;			
options->Append( IDDefault, "Default settings" );

wxMenu *help = new wxMenu;		
help->Append( IDReadme, "Readme" );
help->Append( IDAbout , "About " );


wxMenuBar *menuBar = new wxMenuBar;		//declara bara de meniuri
menuBar->Append( file   , "&File" );		//prinde File in bara de meniuri
menuBar->Append( options, "&Options" );
menuBar->Append( help   , "&Help" );
SetMenuBar( menuBar );

//deocamdata nu trebe
//CreateStatusBar();			//bara aia de jos care nu ajuta la nimic
//SetStatusText( "?" );

panel = new wxPanel(this,-1);	//panou principal, thisu = framu = parintele

//incarca bitmap-u...
bitmap = new wxBitmap(_T("splash.bmp"), wxBITMAP_TYPE_BMP);

//ceva vodoo pt resize
image1 = bitmap->ConvertToImage();
image1.Rescale(1000,500);
delete bitmap;
bitmap = new wxBitmap(image1,-1);

//adauga canvas ( numa pe dasta se poate desena ), panza & culori
//vezi OnPaint [ metoda a Canvas ]
canvas = new Canvas( panel, wxID_ANY, wxPoint(8,208),
					wxSize(bitmap->GetWidth(),bitmap->GetHeight()) );


//DE AICI INCEP BUTOANE, LISTE & TRAPE SECRETE

// adauga un buton cu ID-u..., pozitie, marime ....
/*
button1 = new wxButton(panel, ID_button1, "buton1",wxPoint(128,8), wxSize(64,32), 0);

(void)new wxStaticBox( panel, wxID_ANY, _T("&Box around combobox"),
                           wxPoint(5, 5), wxSize(150, 100));
*/

//prima categorie - ...
generate  = new wxButton(panel, IDgenerate, "GENERATE ",wxPoint(8,32 ), wxSize(128,48),0);
randomize = new wxButton(panel, IDrand    , "RANDOMIZE",wxPoint(8,96 ), wxSize(128,48), 0);
ii_random = new wxCheckBox( panel, wxID_ANY, _T("&Random"),   wxPoint(8,160)   );

(void)  new wxStaticText(panel, wxID_ANY, _T("Seed   "),wxPoint(12,180 ));
seed  = new wxTextCtrl(panel, wxID_ANY, _T("184296 "),wxPoint(48,180 ),wxSize(96,20));


//a 2-a categorie - parametri al modulului generator
(void)new wxStaticBox( panel, wxID_ANY, _T(" &Parameters "),wxPoint(154,32),wxSize(384,162));

(void)new wxStaticText(panel, wxID_ANY, _T("Frequency   "),wxPoint(164,64 ));
(void)new wxStaticText(panel, wxID_ANY, _T("Lacunarity  "),wxPoint(164,96 ));
//(void)new wxStaticText(panel, wxID_ANY, _T("Stretch     "),wxPoint(330,96 ));
(void)new wxStaticText(panel, wxID_ANY, _T("Octave Count"),wxPoint(164,128));
(void)new wxStaticText(panel, wxID_ANY, _T("Persistence "),wxPoint(164,160));
(void)new wxStaticText(panel, wxID_ANY, _T("Resolution  "),wxPoint(330,64 ));


if (def2 == 1)
{
frequency   = new wxTextCtrl(panel, wxID_ANY, _T(" 1   "),wxPoint(256,64 ),wxSize(64,20));
lacunarity  = new wxTextCtrl(panel, wxID_ANY, _T(" 2   "),wxPoint(256,96 ),wxSize(64,20));
//stretch     = new wxTextCtrl(panel, wxID_ANY, _T(" 1   "),wxPoint(400,96 ),wxSize(64,20));
octave      = new wxTextCtrl(panel, wxID_ANY, _T(" 5.5 "),wxPoint(256,128),wxSize(64,20));
persistence = new wxTextCtrl(panel, wxID_ANY, _T(" 0.5 "),wxPoint(256,160),wxSize(64,20));
}
else
{
frequency   = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(256,64 ),wxSize(64,20));
lacunarity  = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(256,96 ),wxSize(64,20));
//stretch   = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(400,96 ),wxSize(64,20));
octave      = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(256,128),wxSize(64,20));
persistence = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(256,160),wxSize(64,20));
}

wxString rezuri[] =
    {
        _T("   64 x 64"),
        _T(" 128 x 128"),
        _T(" 256 x 256"),
        _T(" 512 x 256"),
		_T("1024 x 512"),
        _T("2048 x 1024"),
        _T("4096 x 2048"),
        _T("8192 x 4096")
    };
rezolutie	= new wxComboBox(panel,wxID_ANY, _T(""),
				  wxPoint(400,64), wxSize(96, wxDefaultCoord),
                              8, rezuri,
                              wxCB_READONLY | wxPROCESS_ENTER);
rezolutie->SetValue("1024 x 512");

//a 3-a categorie - SA FIE LUMINA
(void)new wxStaticBox( panel, wxID_ANY, _T(" &Light "),wxPoint(540,32),wxSize(256,162));

(void)new wxStaticText(panel, wxID_ANY, _T("Brightness "),wxPoint(550,64 ));
(void)new wxStaticText(panel, wxID_ANY, _T("Color      "),wxPoint(550,96 ));
(void)new wxStaticText(panel, wxID_ANY, _T("Contrast   "),wxPoint(550,128));
(void)new wxStaticText(panel, wxID_ANY, _T("Intensity  "),wxPoint(550,160));
(void)new wxStaticText(panel, wxID_ANY, _T("Azimuth    "),wxPoint(660,128));
(void)new wxStaticText(panel, wxID_ANY, _T("Elevation  "),wxPoint(660,160));

ni_light = new wxCheckBox( panel, wxID_ANY, _T("&Disable light"),   wxPoint(705,64 )   );
if (def31 == 0) ni_light->SetValue(true);

if (def32 == 1)
{
brightness  = new wxTextCtrl(panel, wxID_ANY, _T("1.25 "),wxPoint(605,64 ),wxSize(48,20));
colorR      = new wxTextCtrl(panel, wxID_ANY, _T("255 "),wxPoint(605,92 ),wxSize(40,20));
colorG      = new wxTextCtrl(panel, wxID_ANY, _T("255 "),wxPoint(647,92 ),wxSize(40,20));
colorB      = new wxTextCtrl(panel, wxID_ANY, _T("255 "),wxPoint(689,92 ),wxSize(40,20));
contrast    = new wxTextCtrl(panel, wxID_ANY, _T("4.0 "),wxPoint(605,128),wxSize(48,20));
intensity   = new wxTextCtrl(panel, wxID_ANY, _T("1.0 "),wxPoint(605,160),wxSize(48,20));

azimuth  = new wxSlider  ( panel, wxID_ANY, 0, 0, 360,wxPoint(710,112),wxSize(80,40),
                             wxSL_AUTOTICKS | wxSL_LABELS);
azimuth->SetTickFreq(45, 0); 
azimuth->SetValue(45);
elevation  = new wxSlider  ( panel, wxID_ANY, 0, 0, 90,wxPoint(710,151),wxSize(80,40),
                             wxSL_AUTOTICKS | wxSL_LABELS);
elevation->SetTickFreq(45, 0); 
elevation->SetValue(70);
}
else
{
brightness  = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(605,64 ),wxSize(48,20));
colorR      = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(605,92 ),wxSize(40,20));
colorG      = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(647,92 ),wxSize(40,20));
colorB      = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(689,92 ),wxSize(40,20));
contrast    = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(605,128),wxSize(48,20));
intensity   = new wxTextCtrl(panel, wxID_ANY, _T(""),wxPoint(605,160),wxSize(48,20));

azimuth  = new wxSlider  ( panel, wxID_ANY, 0, 0, 360,wxPoint(710,112),wxSize(80,40),
                             wxSL_AUTOTICKS | wxSL_LABELS);
azimuth->SetTickFreq(45, 0); 
elevation  = new wxSlider  ( panel, wxID_ANY, 0, 0, 90,wxPoint(710,151),wxSize(80,40),
                             wxSL_AUTOTICKS | wxSL_LABELS);
elevation->SetTickFreq(45, 0); 
}



//a 4-a categorie - gradientii de culoare, lumini si umbre
(void)new wxStaticBox( panel, wxID_ANY, _T(" &Gradients "),wxPoint(798,32),wxSize(215,162));
(void)new wxStaticText(panel, wxID_ANY, _T("Value "),wxPoint(800,64 ));
val = new wxTextCtrl(panel, wxID_ANY, _T("1.0 "),wxPoint(832,64 ),wxSize(48,20));
add = new wxButton(panel, IDadd, "Add point   ",wxPoint(800,96  ), wxSize(80,36),0);
del = new wxButton(panel, IDdel, "Delete point",wxPoint(800,144 ), wxSize(80,36),0);
box = new wxListBox( panel, wxID_ANY,wxPoint(884,50), wxSize(124,130),0,NULL,wxLB_SORT );


if (def4 == 1)
{
box->Append( _T("-1 0 0 128") );
box->Append( _T("-0.25 0 0 255") );
box->Append( _T("0 0 128 255") );
box->Append( _T("0.0625 240 240 64") );
box->Append( _T("0.125 32 160 0") );
box->Append( _T("0.375 224 224 0") );
box->Append( _T("0.75 128 128 128") );
box->Append( _T("1 255 255 255") );
nr_gradienti = 8;
}
else nr_gradienti =0;


}



//din meniu

//file
void Frame::OnSaveBmp(wxCommandEvent& WXUNUSED(event))
{
wxFileDialog sbmp
                 (
                    this,
                    _T("Save as bitmap"),
                    wxEmptyString,
                    wxEmptyString,
                    _T("Bitmap (*.bmp)|*.bmp"),
					wxSAVE|wxOVERWRITE_PROMPT
                 );

    //sbmp.SetDirectory(wxGetHomeDir());
	sbmp.SetFilterIndex(1);

    if (sbmp.ShowModal() == wxID_OK)
    {
    
		wxString path=_T("cmd /Q /c move tmp.bmp \"");
		path.Append(sbmp.GetPath());
		path.Append("\"");
        wxExecute(path);
    }

}
void Frame::OnSaveTex(wxCommandEvent& WXUNUSED(event))
{
wxMessageBox("Not implemented yet","Save as .tex", wxOK | wxICON_INFORMATION, this);
}
void Frame::OnQuit(wxCommandEvent& WXUNUSED(event))		//iesire
{
Close(TRUE);
}



//options
void Frame::OnDefault(wxCommandEvent& WXUNUSED(event))
{
FILE *f;
f=fopen("config.txt","w");


//directoru la orbiter
/*
wxDirDialog odir(this, _T("Please choose the Orbiter directory"),"",wxDEFAULT_DIALOG_STYLE);

    if (odir.ShowModal() == wxID_OK)
    {
        fprintf(f,"%s\n",odir.GetPath().c_str());
    }
*/
//valori default pentru parametri planeta
wxMessageDialog def2( NULL, _T("Add default values for the planet parameters ?"),
        _T("Planet parameters"), wxNO_DEFAULT|wxYES_NO|wxICON_QUESTION);

    switch ( def2.ShowModal() )
    {
        case wxID_YES: fprintf(f,"1\n");break;

        case wxID_NO:  fprintf(f,"0\n");break;
            break;

		default: fprintf(f,"0\n");break;
            
    }
// sa fie lumina?
wxMessageDialog def31( NULL, _T("Enable light by default ?"),
        _T("Light"), wxNO_DEFAULT|wxYES_NO|wxICON_QUESTION);

    switch ( def31.ShowModal() )
    {
        case wxID_YES: fprintf(f,"1\n");break;

        case wxID_NO:  fprintf(f,"0\n");break;
            break;

		default: fprintf(f,"0\n");break;
            
    }
//valori default pentru parametrii luminii
wxMessageDialog def32( NULL, _T("Add default values for the light parameters ?"),
        _T("Light parameters"), wxNO_DEFAULT|wxYES_NO|wxICON_QUESTION);

    switch ( def32.ShowModal() )
    {
        case wxID_YES: fprintf(f,"1\n");break;

        case wxID_NO:  fprintf(f,"0\n");break;
            break;

		default: fprintf(f,"0\n");break;
            
    }
//sa fie gradienti by default?
wxMessageDialog def4( NULL, _T("Add some default gradients?"),
        _T("Gradients"), wxNO_DEFAULT|wxYES_NO|wxICON_QUESTION);

    switch ( def4.ShowModal() )
    {
        case wxID_YES: fprintf(f,"1\n");break;

        case wxID_NO:  fprintf(f,"0\n");break;
            break;

		default: fprintf(f,"0\n");break;
            
    }

fclose(f);

}
//help
void Frame::OnReadme(wxCommandEvent& WXUNUSED(event))
{
wxExecute("notepad readme.txt");
}
void Frame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
	wxMessageBox("                  Planet Editor version 1.0 \n\nSend comments and suggestions to : iaro2004@yahoo.com","About", wxOK | wxICON_INFORMATION, this);
}


//din program
void Frame::OnClik(wxCommandEvent& WXUNUSED(event))	//etest
{
str = new wxString();
float var1=0;
long  var2=0;

module::Perlin perlin;


//Pt frecventa
*str = frequency->GetValue();
var1 = wxAtof( (*str) );
perlin.SetFrequency(var1);

//Pt lacunaritate
*str = lacunarity->GetValue();
var1 = wxAtof( (*str) );
perlin.SetLacunarity(var1);


//Pt octave
*str = octave->GetValue();
var1 = wxAtof( (*str) );
perlin.SetOctaveCount(var1);

//Pt persistenta
*str = persistence->GetValue();
var1 = wxAtof( (*str) );
perlin.SetPersistence(var1);

//Pt seed
if (ii_random->GetValue() == false )
	{
		*str =seed->GetValue();
		 str->ToLong(&var2);
		 perlin.SetSeed(var2);
	}
else	 perlin.SetSeed(rand()%65535);

//================================= detalii in plus pt continente ===================

//============================ / the rabit jumps over the lazy fox ===================






  utils::NoiseMap heightMap;
  utils::NoiseMapBuilderSphere heightMapBuilder;
  //heightMapBuilder.SetSourceModule (final);
    heightMapBuilder.SetSourceModule (perlin);
  //heightMapBuilder.SetSourceModule (detalii);
  //heightMapBuilder.SetSourceModule (masca);
  //heightMapBuilder.SetSourceModule (scale);

  heightMapBuilder.SetDestNoiseMap (heightMap);

//selectare rezolutie
//nu mere cu switchuri

  heightMapBuilder.SetDestSize (1024,512);
  if ( rezolutie->GetValue()== "   64 x 64"  ) heightMapBuilder.SetDestSize (64  ,64  );
  else 
  if ( rezolutie->GetValue()== " 128 x 128"  ) heightMapBuilder.SetDestSize (128 ,128 );
  else 
  if ( rezolutie->GetValue()== " 256 x 256"  ) heightMapBuilder.SetDestSize (256 ,256 );
  else 
  if ( rezolutie->GetValue()== " 512 x 256"  ) heightMapBuilder.SetDestSize (512 ,256 );
  else 
  if ( rezolutie->GetValue()== "1024 x 512"  ) heightMapBuilder.SetDestSize (1024,512 );
  else 
  if ( rezolutie->GetValue()== "2048 x 1024" ) heightMapBuilder.SetDestSize (2048,1024);
  else 
  if ( rezolutie->GetValue()== "4096 x 2048" ) heightMapBuilder.SetDestSize (4096,2048);
  else 
  if ( rezolutie->GetValue()== "8192 x 4096" ) heightMapBuilder.SetDestSize (8192,4096);

  
  heightMapBuilder.SetBounds (-90.0, 90.0, -180.0, 180.0);
  heightMapBuilder.Build ();

  utils::RendererImage renderer;
  utils::Image image;
  renderer.SetSourceNoiseMap (heightMap);
  renderer.SetDestImage (image);
  renderer.ClearGradient ();


double valoare=0;
long   r=0,g=0,b=0;
wxString selection,sel;

for (int i=0;i<nr_gradienti;i++)
{

selection = box->GetString(i);

sel = selection.BeforeFirst(' ');
valoare = wxAtof(sel);
//wxMessageBox(sel,"Enter titlu here.", wxOK | wxICON_INFORMATION, this);

selection = selection.AfterFirst(' ');
sel = selection.BeforeFirst(' ');
sel.ToLong(&r);
//wxMessageBox(sel,"Enter titlu here.", wxOK | wxICON_INFORMATION, this);

selection = selection.AfterFirst(' ');
sel = selection.BeforeFirst(' ');
sel.ToLong(&g);
//wxMessageBox(sel,"Enter titlu here.", wxOK | wxICON_INFORMATION, this);

selection = selection.AfterFirst(' ');
selection.ToLong(&b);
//wxMessageBox(selection,"Enter titlu here.", wxOK | wxICON_INFORMATION, this);

renderer.AddGradientPoint (valoare, utils::Color (r,g,b, 255));

}


//lumina , se iau valorile din categoria 3 si se amesteca bine
//brightness colorR colorG colorB contrast intensity ni_light azimuth elevation

if (ni_light->GetValue() == false)
{
	renderer.EnableLight ();
	
	//Pt brightness
	renderer.SetLightBrightness(wxAtof(brightness->GetValue()));
		
	//Pt culoare
	renderer.SetLightColor(utils::Color (
									wxAtof( colorR->GetValue() ),
									wxAtof( colorB->GetValue() ),
									wxAtof( colorG->GetValue() ),
									255));
	//Pt contrast
	renderer.SetLightContrast(wxAtof(contrast->GetValue()));
	
	//Pt intensitate
	renderer.SetLightIntensity(wxAtof(intensity->GetValue()));

	//Pt azimuth
	renderer.SetLightAzimuth(azimuth->GetValue());
	
	//Pt azimuth
	renderer.SetLightElev   (elevation->GetValue());
	}



  renderer.Render ();
  utils::WriterBMP writer;
  writer.SetSourceImage (image);
  writer.SetDestFilename ("tmp.bmp");
  writer.WriteDestFile ();

sel.Clear();
selection.Clear();
delete str;

delete bitmap;
bitmap = new wxBitmap(_T("tmp.bmp"), wxBITMAP_TYPE_BMP);

//ceva vodoo pt resize
image1 = bitmap->ConvertToImage();
image1.Rescale(1000,500);
delete bitmap;
bitmap = new wxBitmap(image1,-1);

//canvas->Redraw_();
Refresh();
Update();

}

void Frame::OnRand(wxCommandEvent& WXUNUSED(event))
{
float f= 0.5 + ((double)rand() / ((double)(RAND_MAX)+(double)(1))) * 2.71;
frequency->SetValue(  wxString::Format(wxT("%02f"),f)   );

float l= 0.5 + ((double)rand() / ((double)(RAND_MAX)+(double)(1))) * 3;
lacunarity->SetValue(  wxString::Format(wxT("%02f"),l)   );

float o= 1 + ((double)rand() / ((double)(RAND_MAX)+(double)(1))) * 20.71;
octave->SetValue(  wxString::Format(wxT("%02f"),o)   );

float p= 0.25 + ((double)rand() / ((double)(RAND_MAX)+(double)(1))) * 0.65;
persistence->SetValue(  wxString::Format(wxT("%02f"),p)   );

float s=  ((double)rand() / ((double)(RAND_MAX)+(double)(1))) * 4294836225;
seed->SetValue(  wxString::Format(wxT("%02f"),s)   );

}

void Frame::OnAdd(wxCommandEvent& WXUNUSED(event))	//etest
{
date_culoare = new wxColourData(); 
date_culoare->SetChooseFull(true);
culoare = new wxColour();

wxColourData test;

picker = new wxColourDialog(this,date_culoare);
picker->SetTitle(_T("Choose the color value"));
    
if (picker->ShowModal() == wxID_OK)
    {
	   str = new wxString();
	   *str +=val->GetValue();
	   *date_culoare = picker->GetColourData();
	   *culoare = date_culoare->GetColour();
      (*str) += wxString::Format(wxT(" %02d %02d %02d"),
						  culoare->Red(),culoare->Green(),culoare->Blue());
	   box->Append( (*str) );
	   nr_gradienti++;
	   delete str;	   
    } 

delete date_culoare;
delete culoare;
delete picker;

}

void Frame::OnDel(wxCommandEvent& WXUNUSED(event))	//etest
{
int idu;

idu = box->GetSelection();
	if ( idu != wxNOT_FOUND ) { box->Delete( idu ); nr_gradienti--; }
	else wxMessageBox("No gradient selected","", wxOK | wxICON_INFORMATION, this);

}





//constructoru pentru Canvas
Canvas::Canvas(wxWindow *parent,wxWindowID id, const wxPoint& pos, const wxSize& size):
 wxScrolledWindow(parent, wxID_ANY, pos, size)
{
}

// Functia de redesenare
void Canvas::OnPaint(wxPaintEvent& WXUNUSED(event))
{
	
    wxPaintDC dc(this);
    
    if ( bitmap->Ok() )
    {
        wxMemoryDC memDC;
        if ( bitmap->GetPalette() )
		{
            memDC.SetPalette(*bitmap->GetPalette());
            dc.SetPalette	(*bitmap->GetPalette());
        }
        memDC.SelectObject(*bitmap);

        // blit, non-transparent ( ii false la sfarsit )
        dc.Blit(0, 0, bitmap->GetWidth(), bitmap->GetHeight(), & memDC, 0, 0, wxCOPY, false);
        memDC.SelectObject(wxNullBitmap);

		// daca-mi trebe
		//dc.DrawText(_T("Text scris peste bitmap"), 65, 65);
    }
	
}

